
function PostHistory(threadName) {
	
	//定数
	this.FILE_NAME = "_history";
	this.MAX_SIZE = 1000;
	
	this.file = null;
	this.postHistoryDB = new Object();
	this.postHistoryList = new Array();
	
	//-------------------------------
	try {
		var logRoot = getMoonfoxLogRoot();
		var dir = null;
		
		if(logRoot && logRoot.exist())
			dir = new File(logRoot, threadName);
		
		if(dir && dir.exist())
			this.file = new File(dir, this.FILE_NAME);
		
		if(this.file && this.file.exist()) {
			var is = this.file.establishConverterInputStream("UTF-8");
			
			var size = this.file.size();
			var postHistoryStr = "";
			var strbuf = {};
			
			while(is.readString(size, strbuf) != 0) {
				postHistoryStr += strbuf.value;
			}
			
			is.close();
			
			this.postHistoryList = postHistoryStr.split(/\r\n|\n|\r/);
			
			for(var i = 0; i < this.postHistoryList.length; i++)
				this.postHistoryDB[this.postHistoryList[i]] = true;
			
			is.close();
		}
	} catch(e) {
		throw e;
	}
	//----------------------------------
	/**
	 * historyに追加します。
	 * @param {Object} recordList
	 */
	this.append = function(recordList) {
		if(!recordList || recordList.length == 0)
			return;
		
		//含まれていなければ追加
		for(var i = 0; i < recordList.length; i++) {
			if( !this.contain(recordList[i]) ) {
				this.postHistoryList.push(recordList[i].id);
				this.postHistoryDB[recordList[i].id] = true;
			}
		}
		
		//書き出す
		var out = this.file.establishConverterOutputStream("UTF-8");
		var checkLimit = getPref("moonfox.check_limit_day") * 60 * 60 * 24;
		var lastStamp = null;
		
		if(this.postHistoryList[this.postHistoryList.length - 1].match(/([0-9]+)\_/)) {
			lastStamp = parseInt(RegExp.$1);
		}
		
		for(var i = 0; i < this.postHistoryList.length; i++) {
			
			var hist = this.postHistoryList[i];
			var stamp = null;
			
			if(hist.match(/([0-9]+)\_/))
				stamp = parseInt(RegExp.$1);
			else
				continue;
			
			if(!lastStamp || stamp >= lastStamp - checkLimit) {
				out.writeString(hist);
				
				if(i != this.postHistoryList.length - 1) {
					out.writeString("\n");
				}
			}
		}
		
		out.close();
	}
	
	/**
	 * historyに含まれていないレコードが1つでもある場合、trueを返します。
	 * @param {Object} recordFileList
	 */
	this.checkUnreadRecord = function(recordFileList) {
		var unread = false;
		
		for(var i = 0; i < recordFileList.length; i++) {
			var id = recordFileList[i].getName();
			
			if( !this.contain(id) ) {
				unread = true;
				break;
			}
		}
		
		return unread;
	}
	
	/**
	 * 
	 * @param {Object|string} record RecordオブジェクトかレコードのID
	 */
	this.contain = function(record) {
		var found = false;
		
		var id = null;
		
		if(typeof(record) == "string")
			id = record;
		else
			id = record.id;
		
		found = this.postHistoryDB[id];
		
		return found;
	}
	
	/**
	 * 
	 */
	this.getLastStamp = function() {
		var stamp = "0";
		
		if(this.postHistoryList.length == 0)
			return stamp;
		
		var len = this.postHistoryList.length;
		var lastPost = this.postHistoryList[len - 1];
		
		if(lastPost.match(/^([0-9]+)\_[\w]+/))
			stamp = RegExp.$1;	
		
		return stamp;
	}
	
}