
function Record(thNm) {
	
	this.threadName = thNm; //Name  of directory
	this.no = -1;
	this.id = null;
	this.stamp = null;
	this.hash = null;
	this.body = null;
	this.name = "名無しさん";
	this.mail = null;
	this.attach = 0;
	this.suffix = null;
	this.pubkey = null;
	this.sign = null;
	this.target = null;
	this.removeHash = null;
	this.removeStamp = null;
	this.deleteFlg = 0;
	this.unread = false;
	
	/**
	 * 削除解除
	 */
	this.cancelDeletion = function() {
		this.deleteFlg = 0;
	}
	
	/**
	 * 削除設定
	 */
	this.doDeletion = function() {
		this.deleteFlg = 1;
	}
	
	/**
	 * 本レコードに添付されているファイルのFileオブジェクトを返します。
	 */
	this.getAttachFile = function() {
		var target = null;
		var thFile = getThreadFile(this.threadName);
		
		if(!thFile || !thFile.exist())
			return target;
		
		var attachDir = new File(thFile, "attach");
		
		if(!attachDir.exist())
			return target;
		
		var fn = this.id;
		
		if(this.suffix && this.suffix != "")
			fn += "." + this.suffix;
		
		target = new File(attachDir, fn);
		
		return target;
	}
	
	/**
	 *
	 *
	 */
	this.init = function(node) {
		this.id = node.getAttribute("id");
		this.stamp = node.getAttribute("stamp");
		this.hash = node.getAttribute("hash");
		this.no = node.getAttribute("no");
		this.name = node.getAttribute("name");
		this.mail = node.getAttribute("mail");
		this.attach = node.getAttribute("attach");
		this.suffix = node.getAttribute("suffix");
		this.pubkey = node.getAttribute("pubkey");
		this.sign = node.getAttribute("sign");
		this.target = node.getAttribute("target");
		this.removeHash = node.getAttribute("removeHash");
		this.removeStamp = node.getAttribute("removeStamp");
		
		var deleteFlg = node.getAttribute("delete");
		
		if(deleteFlg && deleteFlg == "1")
			this.deleteFlg = "1";
		else
			this.deleteFlg = "0";
		
		//本文読込
		var bodyElem = node.getElementsByTagName("body")[0];
		
		if(bodyElem) {
			var nodes = bodyElem.childNodes;
			
			for(var i = 0; i < nodes.length; i++) {
				if(nodes[i].nodeType == 4) {
					this.body = nodes[i].nodeValue;
				}
			}
		}
	}
	
	/**
	 *
	 */
	this.isAttached = function() {
		var attached = this.attach == 1 || this.attach == "1";
		return attached;
	}
	
	/**
	 *
	 */
	this.isDeleted = function() {
		var deleted = this.deleteFlg == 1 || this.deleteFlg == "1";
		return deleted;
	}
	
	/**
	 *
	 */
	this.isRemovalNotification = function() {
		var noti = this.removeHash && this.removeStamp
					&& this.removeHash != "" && this.removeStamp != "";
		
		return noti;
	}
	
	/**
	 * 
	 * @param {Object} stamp
	 * @param {Object} hash
	 */
	this.setId = function(stamp, hash) {
		if(!stamp || !hash) {
			
		}
		
		this.id = stamp + "_" + hash;
		this.stamp = stamp;
		this.hash = hash;
	}
}