//定数
const ASCEND = 0;
const DESCEND = 1;

const NOT_READ = 0;
const READ = 1;
const UPDATE = 2;

const SHIN_HOME = "http://shingetsu.info/";

//グローバル変数
var threadInfoManager = null;
var mfObserver = null;
var updateTimer = null;
var tagManager = null;
var observeInterval = 5;
var sortType = {
	category:"stamp",
	direction:1
}
var startflg = false;
var public_gateway_mode = false;
var autoUpdate = true;
var tagWindow = null;
var timerId = null;
var winImageViewer = null;

//関数------------------------------

function test() {
try{
	/*
	var arg = {tagManager:null,func:null}
	arg.tagManager = tagManager;
	
	window.open("chrome://moonfox/content/imgviewer/imgviewer.xul"
				, "moonfox_tag"
				, "modal=no,resizable=yes,status=no,toolbar=no"
				, arg);
	*/
	
	//var str = "rphA1H7/UgQi3KCg/4VTytof+UJ2qaMS8xJi+vk1swEHZsypTeqGaQFDja+RDc/ZgD56kHgffnA6L3CsCq+94A";
	//var str = "DyyWUmGgoIxda0ucBXXu/J0My7CSk2TEQg+XrWuEkNIe2/zuFE7DL5v82kp363TXrMfK8/7MTpm0rpiULQnWkA";
	
	//checkStatus(0);
	var tree = document.getElementById("tree_thread");
	tree.view.selection.toggleSelect(0);
	tree.view.selection.toggleSelect(3);
	tree.view.selection.toggleSelect(8);
	
	}catch(e){alert(e);}
}


/*
 * スレッドをツリーに追加します。
 *
 * @param thinfo
 */
function appendToList(thinfo, rowCnt) {
	var list = document.getElementById("treechildren");
	
	var item = document.createElement("treeitem");
	item.setAttribute("id", thinfo.file);
	
	//行要素
	var row = document.createElement("treerow");
	item.appendChild(row);
	
	//ステータス
	var colStatus = document.createElement("treecell");
	colStatus.setAttribute("id", thinfo.file + "_status");

	if(thinfo.status == READ) {
		colStatus.setAttribute("properties", "read");
	} else if(thinfo.status == UPDATE) {
		colStatus.setAttribute("properties", "update");
	} else {
		colStatus.setAttribute("properties", "notread");
	}
	
	row.appendChild(colStatus);
	
	//タイトル
	var colTitle = document.createElement("treecell");
	colTitle.setAttribute("label", thinfo.title);
	row.appendChild(colTitle);
	
	//タグ
	var colSugtag = document.createElement("treecell");
	colSugtag.setAttribute("label", thinfo.getTagAndSugtag());
	row.appendChild(colSugtag);
	
	//書き込み数
	var colNum = document.createElement("treecell");
	colNum.setAttribute("label", thinfo.records);
	row.appendChild(colNum);
	
	//更新日時
	var colUpdate = document.createElement("treecell");
	colUpdate.setAttribute("label", thinfo.date);
	row.appendChild(colUpdate);
	
	//サイズ
	var colSize = document.createElement("treecell");
	var sizeStr = formatSizeStr(thinfo.size);
	colSize.setAttribute("label", sizeStr);
	if(sizeStr.indexOf("MB") >= 0) {
		colSize.setAttribute("properties", "mb");
	}
	row.appendChild(colSize);
	
	list.appendChild(item);
}

/**
 * 
 * @param {Object} nextIndex
 */
function checkStatus() {
	try {
		if(!mfObserver.isComplete()) {
			setTimeout(checkStatus, 1000);
		}
		
		logMsg("スレッドのステータスをMoonfoxObserverより取得開始。", true, checkStatus);
		
		if(threadInfoManager) {
			
			for(var i = 0; i < threadInfoManager.length(); i++) {
				var thinfo = threadInfoManager.getThreadInfo(i);
				
				var status = mfObserver.getStatus(thinfo.file);
				thinfo.status = status;
				var item = document.getElementById(thinfo.file + "_status");
					
				if(item && status == READ) {
					item.setAttribute("properties", "read");
				} else if(item && status == UPDATE) {
					item.setAttribute("properties", "update");
				} else if(item) {
					item.setAttribute("properties", "notread");
				}
			}
			
			if(sortType.category == "status")
				constructTree(true);
		}
		
		logMsg("スレッドのステータスをMoonfoxObserverより取得終了。", true, checkStatus);
	} catch(e) {
		alert(e);
	}
}

/*
 *
 */
function clearTag() {
	document.getElementById("menulist_tag").value = "";
	constructTree(true);
}

/*
 *
 */
function configDataTypeRadio() {
	var rdogrp = document.getElementById("rdogrp_datatype");
	var recent = document.getElementById("rdo_recent");
	var cache = document.getElementById("rdo_cache");
	
	var selectedItem = rdogrp.selectedItem;
	
	if(selectedItem == recent) {
		recent.className = "type_selected";
		cache.className = "type_notselected";
	} else if(selectedItem == cache) {
		recent.className = "type_notselected";
		cache.className = "type_selected";
	}
}

/*
 * 現在のソートタイプに従ってヘッダを変更します。
 */
function configThreadTreeHeader() {
	var headers = document.getElementById("treecols_thread").getElementsByTagName("treecol");
	
	for(var i = 0; i < headers.length; i++)
		headers[i].setAttribute("sortDirection", "natural");
	
	var direction = sortType.direction == ASCEND ? "ascending" : "descending";
	
	if(sortType.category == "status") {
		document.getElementById("treecol_status").setAttribute("sortDirection", direction);
	} else if(sortType.category == "title") {
		document.getElementById("treecol_title").setAttribute("sortDirection", direction);
	} else if(sortType.category == "sugtag") {
		document.getElementById("treecol_sugtag").setAttribute("sortDirection", direction);
	} else if(sortType.category == "records") {
		document.getElementById("treecol_num").setAttribute("sortDirection", direction);
	} else if(sortType.category == "stamp") {
		document.getElementById("treecol_update_date").setAttribute("sortDirection", direction);
	} else if(sortType.category == "size") {
		document.getElementById("treecol_size").setAttribute("sortDirection", direction);
	}
}

/**
 * 
 */
function constructTagCombo() {
	var combo = document.getElementById("menulist_tag");
	var selectedIndex = combo.selectedIndex;
	
	combo.removeAllItems();
	
	for(var i = 0; i < tagManager.length(); i++) {
		combo.appendItem(tagManager.getTag(i), tagManager.getTag(i), "");
	}
	
}

/*
 * スレッドを表示するツリーを構築します。
 *
 * @param show_tree
 */
function constructTree(show_tree) {
	if(!threadInfoManager)
		return;
	
	//状態を保存
	var treeBoxObj = document.getElementById("tree_thread").treeBoxObject;
	var thList = getSelectedThreadList();
	var firstRow = treeBoxObj.getFirstVisibleRow();
	
	//ツリーの内容を削除
	removeAllTreeItem();
	
	var tag = getTagComboValue();
	var filter = document.getElementById("text_filter").value;
	
	var thArray = threadInfoManager.getThreadInfoList(tag, filter, sortType);
	
	for(var i = 0; i < thArray.length; i++) {
		appendToList(thArray[i], i + 1);
	}
	
	//状態を復帰
	treeBoxObj.scrollToRow(firstRow);
	selectThread(thList);
	
	/*スレッド一覧に切り替え
	if(show_tree) {
		turnToTree();
	}*/
}

/*
 *
 */
function dataLoaded(thinfomngr) {
	threadInfoManager = thinfomngr;
	
	var change = tagManager.add(thinfomngr.getTagList());
	
	if(change) {
		constructTagCombo();
	}
	
	constructTree(true);
	
	//プログレスメータをストップ
	document.getElementById("progress").mode = "determined";
	document.getElementById("progress").hidden = true;
	
	document.getElementById("label_message").value = "";
	
	if(!public_gateway_mode) {
		mfObserver.start();
		checkStatus();
	}
}

/*
 * gateway.cgiとのやり取りに失敗した場合。
 */
function dataLoadError() {
	//プログレスメータをストップ
	document.getElementById("progress").mode = "determined";
	document.getElementById("progress").hidden = true;
	
	document.getElementById("label_message").value = "Error";
	//alert(msg("E_01"));
}

/*
 * スレッドを削除します。
 */
function deleteThread() {
	try {
		/*
		if(public_gateway_mode) {
			alert(msg("I_02"));
			return;
		}*/
		
		var selectedArray = getSelectedThreadList();
		
		if(selectedArray && selectedArray.length > 0) {
			var ret = { ok:false};
			
			window.openDialog("chrome://moonfox/content/delete/delete.xul"
				, "moonfox_delete"
				, "modal=yes,resizable=yes"
				, ret
				, selectedArray);
			
			//削除した場合はデータを再取得
			if(ret.ok)
				checkStatus();
		}
	} catch(e) {
		alert(e);
	}
}


/*
 * 新月ネットワークからデータを取得します。
 */
function fetchData() {
	logMsg("gateway.cgiにリクエスト送信。", true, fetchData);
	
	//新着かキャッシュか
	var rdogrp = document.getElementById("rdogrp_datatype");
	var val = rdogrp.selectedItem.value;
	
	//プログレスメータ
	document.getElementById("progress").mode = "undetermined";
	document.getElementById("progress").hidden = false;
	
	if(val == "recent") {
		getRecentData(public_gateway_mode, dataLoaded, dataLoadError);
	} else if(val == "cache") {
		getCacheData(public_gateway_mode, dataLoaded, dataLoadError);
	} else {
		alert("Error fetchData()");
	}
}



/*
 * 現在選択されているスレッドを返します。
 *
 * @return
 */
function getSelectedThread() {
	var thinfo = null;
	var tree = document.getElementById("tree_thread");
	var index = tree.currentIndex;
	
	if(index >= 0 ) {
		var title = tree.view.getCellText(index, tree.columns[1]);
		thinfo = threadInfoManager.getThreadInfoByTitle(title);
	}
	
	return thinfo;
}

/*
 * 現在選択されているスレッドの配列を返します。
 *
 * @return
 */
function getSelectedThreadList() {
	var selectedArray = new Array();
	var tree = document.getElementById("tree_thread");
	var start = {value:0};
	var end = {value:0};
	var title = null;
	var rangeCnt = tree.view.selection.getRangeCount();
	
	for(var i = 0; i < rangeCnt; i++) {
		tree.view.selection.getRangeAt(i, start, end);
		
		for(var j = start.value; j <= end.value; j++) {
			title = tree.view.getCellText(j, tree.columns[1]);
			thinfo = threadInfoManager.getThreadInfoByTitle(title);
			selectedArray.push(thinfo);
		}
	}
	
	return selectedArray;
}

/*
 *
 */
function getTagComboValue() {
	var val = null;
	var combo = document.getElementById("menulist_tag");
	val = combo.value;
	
	return val;
}

/*
 *
 */
function receiveFromTagDialog(tag) {
	document.getElementById("menulist_tag").value = tag;
	constructTree(true);
}

/*
 *
 */
function removeAllTreeItem() {
	var tree = document.getElementById("treechildren");
	//var arr = tree.childNodes;
	
	while(tree.firstChild)
		tree.removeChild(tree.firstChild);
	/*
	for(var i = arr.length-1; i >= 0; i--)
		document.getElementById("treechildren").removeChild(arr[i]);*/
}

/**
 * 指定されたスレッドを選択状態にします。
 */
function selectThread(threadList) {
	if(!threadList || threadList.length == 0)
		return;
	
	var selectDB = {};
	var selLen = threadList.length;
	var cnt = 0;
	var tree = document.getElementById("tree_thread");
	
	for(var i = 0; i < threadList.length; i++)
		selectDB[threadList[i].title] = true;
	
	for(var i = 0; i < tree.view.rowCount; i++) {
		
		var title = tree.view.getCellText(i, tree.columns[1]);
		
		if(selectDB[title]) {
			tree.view.selection.toggleSelect(i);
			cnt += 1;
			
			if(cnt == selLen)
				break;
		}
	}
}

/*
 *
 */
function showPage(url, my_browser, title) {
	if(!my_browser) {
	
		var ctrl = new BrowserController();
		ctrl.openAtNewTab(url, true);
		
	} else {
		var br = document.getElementById("browser_viewer");
		setShowingThreadTitle(title);
		turnToViewer();
		
		if(br.src != url) {
			br.src = url;
			br.setAttribute("src", url);
		} else {
			br.reload();
		}
	}
}

/**
 * 
 */
function showThread(thinfoList) {
	if(public_gateway_mode) {
		//公開ゲートウェイの場合はthread.cgiで開く
		showThreadByThreadcgi(thinfoList);
	} else {
		for(var i = 0; i < thinfoList.length; i++) {
			var url = "chrome://moonfox/content/thread/thread.html?fn=" + thinfoList[i].file;
			
			showPage(url, false, thinfoList[i].title);
			
			thinfoList[i].status = READ;
			mfObserver.setStatus(thinfoList[i].file, READ);
			var item = document.getElementById(thinfoList[i].file + "_status");
			
			if(item) {
				item.setAttribute("properties", "read");
			}
		}
	}
}

/**
 * スレッドを表示します。
 *
 * @param thinfo
 */
function showThreadByThreadcgi(thinfoList) {
	for(var i = 0; i < thinfoList.length; i++) {
		var url = getSakuRootUrl() + thinfoList[i].path;
		
		showPage(url, false, thinfoList[i].title);
		
		//公開ゲートウェイ閲覧の場合は既読に設定
		if(public_gateway_mode) {
			thinfoList[i].status = READ;
			
			var item = document.getElementById(thinfoList[i].file + "_status");
			
			if(item)
				item.setAttribute("properties", "read");
		}
	}
}

/*
 * スレッドを新しいタブで開きます。
 *
 * @param thinfoArray
 */
function showThreadAtNewTab(thinfoArray) {
	for(var i = 0; i < thinfoArray.length; i++) {
		var url = getSakuRootUrl() + thinfoArray[i].path;
		
		showPage(url, false, thinfoArray[i].title);
		
		thinfoArray[i].status = READ;
	}
	
	if(thinfoArray.length > 0)
		constructTree(false);
}

/*
 *
 */
function sortThread(category) {
	if(sortType.category == category) {
		if(sortType.direction == ASCEND)
			sortType.direction = DESCEND;
		else
			sortType.direction = ASCEND;
	} else {
		sortType.category = category;
	}
	
	configThreadTreeHeader();
	constructTree(true);
}

/*
 * 公開ゲートウェイ閲覧モードの設定を行います。
 */
function startPublicGatewayMode() {
	public_gateway_mode = true;
//	document.getElementById("rdogrp_datatype").value = "cache";
//	document.getElementById("rdo_recent").disabled = true;
//	document.getElementById("mitem_delete").setAttribute("disabled", true);
}

/*
 *
 */
function turnContentPane() {
	var deck = document.getElementById("deck_contentpane");
	var cur = deck.selectedIndex;
	
	if(cur == 0) {
		turnToViewer();
	} else {
		turnToTree();
	}
}

/*
 *
 */
function turnToTree() {
	var deck = document.getElementById("deck_contentpane");
	deck.selectedIndex = 0;
	remeoveBrowserMenu();
}

/*
 *
 */
function turnToViewer() {
	var deck = document.getElementById("deck_contentpane");
	deck.selectedIndex = 1;
	showBrowserMenu();
}

/*
 * データタイプラジオクリック時。
 */
function typeRadioClicked(rdogrp) {
	configDataTypeRadio();
	fetchData();
}